diff --git a/src/backend/commands/analyze.c b/src/backend/commands/analyze.c
index f952b3c..3369784 100644
--- a/src/backend/commands/analyze.c
+++ b/src/backend/commands/analyze.c
@@ -2309,6 +2309,8 @@ compute_scalar_stats(VacAttrStatsP stats,
 	bool		is_varwidth = (!stats->attrtype->typbyval &&
 							   stats->attrtype->typlen < 0);
 	double		corr_xysum;
+	double		corr_ysum;
+	double		corr_y2sum;
 	SortSupportData ssup;
 	ScalarItem *values;
 	int			values_cnt = 0;
@@ -2429,6 +2431,8 @@ compute_scalar_stats(VacAttrStatsP stats,
 		 * be ordered by tupno).
 		 */
 		corr_xysum = 0;
+		corr_ysum = 0;
+		corr_y2sum = 0;
 		ndistinct = 0;
 		nmultiple = 0;
 		dups_cnt = 0;
@@ -2436,7 +2440,9 @@ compute_scalar_stats(VacAttrStatsP stats,
 		{
 			int			tupno = values[i].tupno;
 
-			corr_xysum += ((double) i) * ((double) tupno);
+			corr_xysum += ((double) ndistinct) * ((double) tupno);
+			corr_ysum += ((double) ndistinct);
+			corr_y2sum += ((double) ndistinct) * ((double) ndistinct);
 			dups_cnt++;
 			if (tupnoLink[tupno] == tupno)
 			{
@@ -2777,11 +2783,11 @@ compute_scalar_stats(VacAttrStatsP stats,
 			MemoryContextSwitchTo(old_context);
 
 			/*----------
-			 * Since we know the x and y value sets are both
+			 * Since we know the x value sets are
 			 *		0, 1, ..., values_cnt-1
-			 * we have sum(x) = sum(y) =
+			 * we have sum(x) = 
 			 *		(values_cnt-1)*values_cnt / 2
-			 * and sum(x^2) = sum(y^2) =
+			 * and sum(x^2) = 
 			 *		(values_cnt-1)*values_cnt*(2*values_cnt-1) / 6.
 			 *----------
 			 */
@@ -2791,8 +2797,8 @@ compute_scalar_stats(VacAttrStatsP stats,
 				((double) values_cnt) * (double) (2 * values_cnt - 1) / 6.0;
 
 			/* And the correlation coefficient reduces to */
-			corrs[0] = (values_cnt * corr_xysum - corr_xsum * corr_xsum) /
-				(values_cnt * corr_x2sum - corr_xsum * corr_xsum);
+			corrs[0] = (values_cnt * corr_xysum - corr_xsum * corr_ysum) /
+				sqrt((values_cnt * corr_x2sum - corr_xsum) * (values_cnt * corr_y2sum - corr_ysum));
 
 			stats->stakind[slot_idx] = STATISTIC_KIND_CORRELATION;
 			stats->staop[slot_idx] = mystats->ltopr;
